﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

//ここを追加
using System.Runtime.Remoting.Channels.Ipc;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting;
using RemoteTranceObject;
//ここを追加

namespace ProTestClient
{
	public partial class Form1 : Form
	{
		private int m_mode;
		private ClassFileInfo m_msg = null;

		//コンストラクタ
		public Form1()
		{
			InitializeComponent();

			m_mode = 1;
		}

		//フォームロード
		private void Form1_Load(object sender, EventArgs e)
		{
			//このチャネル生成系は一度通せばいいっぽい
			
			// IPC Channel を作成
			IpcClientChannel clientChannel = new IpcClientChannel();

			// リモートオブジェクトを登録
			ChannelServices.RegisterChannel(clientChannel, true);

			// オブジェクトを作成
			m_msg = (ClassFileInfo)Activator.GetObject(typeof(ClassFileInfo), "ipc://processtrancetest/message");

		}

		//ラジオボタンでモードを設定
		private void rdbClick(object sender, EventArgs e)
		{

			string st = (sender as RadioButton).Tag as string;

			m_mode = int.Parse(st);

		}

		//ボタンを押すたびに，モードと入力文字をサーバ側へ送信
		private void button1_Click(object sender, EventArgs e)
		{
			string st = textBox1.Text;

			if (st == "")
			{
				st = "空文字";
			}

			m_msg.DataTrance(m_mode, st);				//サーバーへ伝送
		}

	}
}

namespace RemoteTranceObject				//共有オブジェクト(サーバー/クライアントで全く同一内容で定義してください)
{
    public class ClassFileInfo : MarshalByRefObject
    {
		public class ClassFileInfoEventArg : EventArgs			//情報を引き渡すイベント引数クラス
		{
			private int m_mode = 0;					//モード
			private string m_FileName = "";			//文字列

			public int Mode { get { return m_mode; } set {m_mode = value;}}
			public string FileName { get { return m_FileName; } set {m_FileName = value;}}

			public ClassFileInfoEventArg(int tmpMode, string tmpfName)
			{
				m_mode = tmpMode;
				m_FileName = tmpfName;
			}
		}

		public delegate void CallEventHandler(ClassFileInfoEventArg e);
		public event CallEventHandler OnTrance;
	        
		public void DataTrance(int tmpmode, string tmpfname)
		{
			if (OnTrance != null)
			{
				OnTrance(new ClassFileInfoEventArg(tmpmode, tmpfname));
			}
		}
		
    }
}
