﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

//ここを追加
using System.Runtime.Remoting.Channels.Ipc;
using System.Runtime.Remoting.Channels;
using System.Runtime.Remoting;
using RemoteTranceObject;
//ここを追加


namespace ProTestServer
{
	public partial class Form1 : Form
	{
		private ClassFileInfo m_msg;

		//コンストラクタ
		public Form1()
		{
			InitializeComponent();
		}

		//フォームロード
		private void Form1_Load(object sender, EventArgs e)
		{
			//このチャネル生成系は一度通せばいいっぽい

			// IPC Channelを作成
			IpcServerChannel servChannel = new IpcServerChannel("processtrancetest");
	        
			// リモートオブジェクトを登録
			ChannelServices.RegisterChannel(servChannel, true);

			//// ChannelのURIを表示
			label1.Text = servChannel.GetChannelUri();

			// イベントを登録
			m_msg = new ClassFileInfo();

			m_msg.OnTrance += new ClassFileInfo.CallEventHandler(m_msg_OnTrance);

			RemotingServices.Marshal(m_msg, "message", typeof(ClassFileInfo));
		}

		//クライアントから転送されてきた情報をリストボックスに表示
		void m_msg_OnTrance(ClassFileInfo.ClassFileInfoEventArg e)
		{
			string st;

			switch(e.Mode)
			{
				case 1:
					st = "モード１";
					break;
				case 2:
					st = "モード２";
					break;
				case 3:
					st = "モード３";
					break;
				default:
					st = "???";
					break;
			}


			listBox1.Items.Add(st + " , " + e.FileName);
		}
	}
}


namespace RemoteTranceObject				//共有オブジェクト(サーバー/クライアントで全く同一内容で定義してください)
{
    public class ClassFileInfo : MarshalByRefObject
    {
		public class ClassFileInfoEventArg : EventArgs			//情報を引き渡すイベント引数クラス
		{
			private int m_mode = 0;					//モード
			private string m_FileName = "";			//文字列

			public int Mode { get { return m_mode; } set {m_mode = value;}}
			public string FileName { get { return m_FileName; } set {m_FileName = value;}}

			public ClassFileInfoEventArg(int tmpMode, string tmpfName)
			{
				m_mode = tmpMode;
				m_FileName = tmpfName;
			}
		}

		public delegate void CallEventHandler(ClassFileInfoEventArg e);
		public event CallEventHandler OnTrance;
	        
		public void DataTrance(int tmpmode, string tmpfname)
		{
			if (OnTrance != null)
			{
				OnTrance(new ClassFileInfoEventArg(tmpmode, tmpfname));
			}
		}
		
    }
}
